/usr/lib/ocf/resource.d/heartbeat/syslog-ng is in resource-agents 1:3.9.2-5ubuntu4.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 | #!/bin/bash
#
# Description: Manages a syslog-ng instance, provided by NTT OSSC as an
# OCF High-Availability resource under Heartbeat/LinuxHA control
#
# Copyright (c) 2009 NIPPON TELEGRAPH AND TELEPHONE CORPORATION
#
##############################################################################
# OCF parameters:
# OCF_RESKEY_syslog_ng_binary : Path to syslog-ng binary.
# Default is "/sbin/syslog-ng"
# OCF_RESKEY_configfile : Configuration file
# OCF_RESKEY_start_opts : Startup options
# OCF_RESKEY_kill_term_timeout: Number of seconds to await to confirm a
# normal stop method
#
# Only OCF_RESKEY_configfile must be specified. Each of the rests
# has its default value or refers OCF_RESKEY_configfile to make
# its value when no explicit value is given.
#
# Further infomation for setup:
# There are sample configurations at the end of this file.
#
###############################################################################
: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
usage()
{
cat <<-!
usage: $0 action
action:
start : start a new syslog-ng instance
stop : stop the running syslog-ng instance
status : return the status of syslog-ng, run or down
monitor : return TRUE if the syslog-ng appears to be working.
meta-data : show meta data message
validate-all: validate the instance parameters
!
return $OCF_ERR_UNIMPLEMENTED
}
metadata_syslog_ng()
{
cat <<END
<?xml version="1.0"?>
<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">
<resource-agent name="syslog-ng">
<version>1.0</version>
<longdesc lang="en">
This script manages a syslog-ng instance as an HA resource.
</longdesc>
<shortdesc lang="en">Syslog-ng resource agent</shortdesc>
<parameters>
<parameter name="configfile" unique="0" required="1">
<longdesc lang="en">
This parameter specifies a configuration file
for a syslog-ng instance managed by this RA.
</longdesc>
<shortdesc>Configuration file</shortdesc>
<content type="string" default=""/>
</parameter>
<parameter name="syslog_ng_binary" unique="0">
<longdesc lang="en">
This parameter specifies syslog-ng's executable file.
</longdesc>
<shortdesc>syslog-ng executable</shortdesc>
<content type="string" default="/sbin/syslog-ng"/>
</parameter>
<parameter name="start_opts" unique="0">
<longdesc lang="en">
This parameter specifies startup options for a
syslog-ng instance managed by this RA. When no value is given, no startup
options is used. Don't use option '-F'. It causes a stuck of a start action.
</longdesc>
<shortdesc>Start options</shortdesc>
<content type="string" default=""/>
</parameter>
<parameter name="kill_term_timeout" unique="0">
<longdesc lang="en">
On a stop action, a normal stop method(pkill -TERM) is firstly used.
And then the confirmation of its completion is waited for
the specified seconds by this parameter.
The default value is 10.
</longdesc>
<shortdesc>Number of seconds to await to confirm a normal stop method</shortdesc>
<content type="integer" default="10"/>
</parameter>
</parameters>
<actions>
<action name="start" timeout="60s" />
<action name="stop" timeout="120s" />
<action name="status" timeout="60s" />
<action name="monitor" depth="0" timeout="60s" interval="60s" />
<action name="meta-data" timeout="5s" />
<action name="validate-all" timeout="5"/>
</actions>
</resource-agent>
END
return $OCF_SUCCESS
}
monitor_syslog_ng()
{
set -- $(pgrep -f "$PROCESS_PATTERN" 2>/dev/null)
case $# in
0) ocf_log debug "No syslog-ng process for $CONFIGFILE"
return $OCF_NOT_RUNNING;;
1) return $OCF_SUCCESS;;
esac
ocf_log warn "Multiple syslog-ng process for $CONFIGFILE"
return $OCF_SUCCESS
}
start_syslog_ng()
{
monitor_syslog_ng
if [[ $? = "$OCF_SUCCESS" ]]; then
return $OCF_SUCCESS
fi
# set -- $SYSLOG_NG_OPTS
# ocf_run "$SYSLOG_NG_EXE" -f "$SYSLOG_NG_CONF" "$@"
# reduce to this?
ocf_run "$SYSLOG_NG_EXE" -f "$CONFIGFILE" $START_OPTS
ocf_status=$?
if [[ "$ocf_status" != "$OCF_SUCCESS" ]]; then
return $OCF_ERR_GENERIC
fi
while true; do
monitor_syslog_ng
if [[ $? = "$OCF_SUCCESS" ]]; then
return $OCF_SUCCESS
fi
sleep 1
done
}
stop_syslog_ng()
{
pkill -TERM -f "$PROCESS_PATTERN"
typeset lapse_sec=0
while pgrep -f "$PROCESS_PATTERN" > /dev/null; do
sleep 1
lapse_sec=$(( lapse_sec + 1 ))
ocf_log debug "stop_syslog_ng[$SYSLOG_NG_NAME]: stop NORM $lapse_sec/$KILL_TERM_TIMEOUT"
if [ $lapse_sec -ge $KILL_TERM_TIMEOUT ]; then
break
fi
done
# if the process can't be removed, then the following part is
# not going to be executed (the RA will be killed by lrmd on
# timeout) and the pidfile will remain; don't know if that
# has any consequences
# 2009/09/18 Nakahira
# If the syslog-ng process hangs, syslog-ng RA waits
# $KILL_TERM_TIMEOUT seconds.
# The stop timeout of RA should be longer than $KILL_TERM_TIMEOUT.
lapse_sec=0
while pgrep -f "$PROCESS_PATTERN" > /dev/null; do
pkill -KILL -f "$PROCESS_PATTERN"
sleep 1
lapse_sec=$(( lapse_sec + 1 ))
ocf_log debug "stop_syslog_ng[$SYSLOG_NG_NAME]: suspend syslog_ng by SIGKILL ($lapse_sec/@@@)"
done
return $OCF_SUCCESS
}
status_syslog_ng()
{
# ???? why not monitor and then print running or stopped
monitor_syslog_ng
rc=$?
if [ $rc = $OCF_SUCCESS ]; then
echo "Syslog-ng service is running."
elif [ $rc = $OCF_NOT_RUNNING ]; then
echo "Syslog-ng service is stopped."
else
echo "Mutiple syslog-ng process for $CONFIGFILE."
fi
return $rc
}
validate_all_syslog_ng()
{
ocf_log info "validate_all_syslog_ng[$SYSLOG_NG_NAME]"
return $OCF_SUCCESS
}
if [[ "$1" = "meta-data" ]]; then
metadata_syslog_ng
exit $?
fi
CONFIGFILE="${OCF_RESKEY_configfile}"
if [[ -z "$CONFIGFILE" ]]; then
ocf_log err "undefined parameter:configfile"
exit $OCF_ERR_CONFIGURED
fi
SYSLOG_NG_NAME=${CONFIGFILE##*/}
SYSLOG_NG_NAME=${SYSLOG_NG_NAME%.*}
SYSLOG_NG_EXE="${OCF_RESKEY_syslog_ng_binary-/sbin/syslog-ng}"
# why not default to /sbin/syslog-ng?
#if [[ -z "$SYSLOG_NG_EXE" ]]; then
# ocf_log err "Undefined parameter:syslog_ng_binary"
# exit $OCF_ERR_CONFIGURED
#fi
if [[ ! -x "$SYSLOG_NG_EXE" ]]; then
ocf_log err "Invalid value:syslog_ng_binary:$SYSLOG_NG_EXE"
exit $OCF_ERR_CONFIGURED
fi
# actually, the pidfile has no function; the status is checked by
# testing for a running process only
KILL_TERM_TIMEOUT="${OCF_RESKEY_kill_term_timeout-10}"
if ! ocf_is_decimal "$KILL_TERM_TIMEOUT"; then
ocf_log err "Invalid value:kill_term_timeout:$KILL_TERM_TIMEOUT"
exit $OCF_ERR_CONFIGURED
fi
START_OPTS=${OCF_RESKEY_start_opts}
PROCESS_PATTERN="$SYSLOG_NG_EXE -f $CONFIGFILE"
COMMAND=$1
case "$COMMAND" in
start)
ocf_log debug "[$SYSLOG_NG_NAME] Enter syslog_ng start"
start_syslog_ng
func_status=$?
ocf_log debug "[$SYSLOG_NG_NAME] Leave syslog_ng start $func_status"
exit $func_status
;;
stop)
ocf_log debug "[$SYSLOG_NG_NAME] Enter syslog_ng stop"
stop_syslog_ng
func_status=$?
ocf_log debug "[$SYSLOG_NG_NAME] Leave syslog_ng stop $func_status"
exit $func_status
;;
status)
status_syslog_ng
exit $?
;;
monitor)
#ocf_log debug "[$SYSLOG_NG_NAME] Enter syslog_ng monitor"
monitor_syslog_ng
func_status=$?
#ocf_log debug "[$SYSLOG_NG_NAME] Leave syslog_ng monitor $func_status"
exit $func_status
;;
validate-all)
validate_all_syslog_ng
exit $?
;;
*)
usage
;;
esac
# vim: set sw=4 ts=4 :
### A sample snippet of cib.xml for a syslog-ng resource
##
# <primitive id="prmApSyslog-ng" class="ocf" type="syslog-ng" provider="heartbeat">
# <instance_attributes id="prmDummyB_instance_attrs">
# <attributes>
# <nvpair id="atr:Syslog-ng:syslog-ng:configfile" name="configfile" value="/etc/syslog-ng/syslog-ng-ext.conf"/>
# </attributes>
# </instance_attributes>
# <operations>
# <op id="op:prmSyslog-ng:start" name="start" timeout="60s" on_fail="restart"/>
# <op id="op:prmSyslog-ng:monitor" name="monitor" interval="10s" timeout="60s" on_fail="restart"/>
# <op id="op:prmSyslog-ng:stop" name="stop" timeout="60s" on_fail="block"/>
# </operations>
# </primitive>
### A sample syslog-ng configuration file for a log collecting host
###
### This sample is for a log collecting host by syslog-ng.
### A syslog-ng process configurated by this sample accepts all messages
### from a certain network. Any message from the network is preserved into
### a file for security infomation. Restricting messages to "authpriv" from
### the network is done on log sending hosts. (See the sample below)
### Any internal message of the syslog-ng process is preserved into its
### dedicated file. And any "authpriv" internal message of the syslog-ng
### process is also preserved into the security infomation file.
###
### Change "f_incoming" to suit your enviroment.
### If you use it as a configuration file for the sample cib.xml above,
### save it into "/etc/syslog-ng/syslog-ng-ext.conf".
##
#options {
# sync (0);
# time_reopen (10);
# log_fifo_size (1000);
# long_hostnames (off);
# use_dns (yes);
# use_fqdn (no);
# create_dirs (no);
# keep_hostname (yes); };
#
#source s_internal { internal(); };
#source s_incoming { udp(port(514)); };
#filter f_internal { facility(authpriv); };
#filter f_incoming { netmask("172.20.0.0/255.255.192.0"); };
#
#destination d_internal { file("/var/log/syslog-ng-ext.log" perm(0640));};
#destination d_incoming {
# file("/var/log/secure-ext.log" create_dirs(yes) perm(0640)); };
#
#log { source(s_internal); destination(d_internal); };
#log { source(s_internal); filter(f_internal); destination(d_incoming); };
#log { source(s_incoming); filter(f_incoming); destination(d_incoming); };
### A sample snippet of syslog-ng configuration file for a log sending host
###
### This sample is for a log sending host that uses syslog-ng.
###
### Replace "syslog-ng-ext" to the IP address or the hostname of your
### log collecting host and append it to "syslog-ng.conf" of each log sending
### host. See the install default syslog-ng.conf to know what "s_sys" and
### "f_auth" are.
##
#destination d_outgoing { udp("syslog-ng-ext" port(514)); };
#log { source(s_sys); filter(f_auth); destination(d_outgoing); };
### A sample snippet of syslog configuration file for a log sending host
###
### This sample is for a log sending host that uses syslog.
###
### Replace "syslog-ng-ext" to the IP address or the hostname of your
### log collecting host and append it to "syslog.conf" of each log sending
### host.
##
# authpriv.* @syslog-ng-ext
|